package accrue.analysis.goals;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.frontend.Scheduler;
import polyglot.frontend.goals.Goal;
import polyglot.frontend.goals.VisitorGoal;
import polyglot.types.TypeSystem;
import polyglot.visit.InnerClassRemover;
import accrue.AccrueScheduler;

public class MoveInnerClassesGoal extends VisitorGoal {
    public static Goal create(Scheduler scheduler, Job job, TypeSystem ts,
            NodeFactory nf) {
        return scheduler.internGoal(new MoveInnerClassesGoal(job, ts, nf));
    }

    protected MoveInnerClassesGoal(Job job, TypeSystem ts, NodeFactory nf) {
        super(job, new InnerClassRemover(job, ts, nf));
    }

    @Override
    public Collection<Goal> prerequisiteGoals(Scheduler scheduler) {
        List<Goal> l = new ArrayList<Goal>();
        l.add(((AccrueScheduler) scheduler).helper().PreModificationBarrier());
        l.add(((AccrueScheduler) scheduler).helper().MoveLocalClassesGoal(job));

        l.addAll(super.prerequisiteGoals(scheduler));
        return l;
    }
}
